function AppAssistant(appController) {
	
	try {
		this.database = openDatabase("org.webosinternals.terminal", 1, "Terminal Preferences Database", 1000);
	}
	catch (e) {
		Mojo.Log.logException(e, "AppAssistant#AppAssistant: Database FAILED to open.");
	}
	
}

AppAssistant.prototype.handleLaunch = function(params) {
	
    try {
    	
        var launchParams = {};
    
        if (Object.isString(params)) {
            if (params.isJSON()) {
                launchParams = params.evalJSON();
            }
        } else {
        	launchParams = params;
        }

        if (Mojo.Controller.appInfo.noWindow) {
        	
            var f = function(stageController) {

            	if (launchParams.target) {
                    launchParams.target = launchParams.target.stripScripts().stripTags();
                }
            	
                var sceneParams = {
                    launchParams: launchParams
                };

                stageController.pushScene({name:'session'}, sceneParams);
                
            };
            
            var stageName = "session-" + Date.now();
            this.controller.createStageWithCallback({name: stageName, lightweight: true}, f);
            
        } else if(params.banner) {
        	
            Mojo.Log.warn("Notifications not yet implemented.");
            
        }
        
    } catch (e) {
    	
        Mojo.Log.logException(e, "AppAssistant#handleLaunch");
        
    }
    
};

AppAssistant.prototype.cleanup = function() {
	
};