var PrefsAssistant = Class.create( {
        setup: function() {
                this.fontChoices = [
                        {label: 'Normal', value: 'normal'},
                        {label: 'Small', value: 'small'}
                ];
                this.fontModel = {
                        value: 'small',
                        disabled: false
                };
                if (Prefs.fontWidth==8) {
                        this.fontModel.value = 'normal';
                }
                else {
                        this.fontModel.value = 'small';
                }
                this.controller.setupWidget(
                        'fontSelector',
                        {
                                label: "Size",
                                choices: this.fontChoices,
                        },
                        this.fontModel
                );
                fontSelector = this.controller.get('fontSelector');
                Mojo.Event.listen(fontSelector, Mojo.Event.propertyChange, this.updateFont.bind(this))


                this.colorChoices = [
                        {label: 'Black',   value:0},
                        {label: 'Red',     value:1},
                        {label: 'Green',   value:2},
                        {label: 'Yellow',  value:3},
                        {label: 'Blue',    value:4},
                        {label: 'Magenta', value:5},
                        {label: 'Cyan',    value:6},
                        {label: 'White',   value:7}
                        ];


                this.bgColorModel = { value: Prefs.bgColor, disabled: false };
                this.controller.setupWidget('bgColorSelector',	{ label: "Background", choices: this.colorChoices, }, this.bgColorModel);
                bgColorSelector = this.controller.get('bgColorSelector');
                Mojo.Event.listen(bgColorSelector, Mojo.Event.propertyChange, this.updateBgColor.bind(this));

                this.fgColorModel = { value:Prefs.fgColor, disabled: false };
                this.controller.setupWidget('fgColorSelector',	{ label: "Foreground", choices: this.colorChoices, }, this.fgColorModel);
                fgColorSelector = this.controller.get('fgColorSelector');
                Mojo.Event.listen(fgColorSelector, Mojo.Event.propertyChange, this.updateFgColor.bind(this));
        },
        updateFont: function(event) {
                if (this.fontModel.value=='normal') {
                        Prefs.fontWidth=8;
                        Prefs.fontHeight=8;
                }
                else {
                        Prefs.fontWidth=4;
                        Prefs.fontHeight=6;
                }
        },
		updateBgColor: function(event) {
			Prefs.bgColor = this.bgColorModel.value;
        },
		updateFgColor: function(event) {
			Prefs.fgColor = this.fgColorModel.value;
        },
});

