Prefs = {}
Prefs.fontWidth=8;
Prefs.fontHeight=8;
Prefs.fgColor=7;
Prefs.bgColor=0;

function SessionAssistant() {
	
	this.termplugin	= undefined;
	this.placeholder = undefined;
	this.headerHeight = undefined;
	this.footerHeight = undefined;
	this.terminalWidth = undefined;
	this.terminalHeight = undefined;
	this.scroller = undefined;
	this.savedFlickSpeed = undefined;
	this.savedFlickRatio = undefined;
	
	this._onKeyDownEventHandler = this._onKeyDownEvent.bind(this);
	
}

SessionAssistant.prototype.setup = function() {

	try {
		
		Mojo.Log.info("SessionAssistant#setup");
		
		var targetWindow = this.controller.window;
		if (targetWindow.PalmSystem && targetWindow.PalmSystem.setWindowOrientation) {
			targetWindow.PalmSystem.setWindowOrientation("free");
		}
		
		// Allow override of 'back' gesture in landscape mode.
		this.controller.useLandscapePageUpDown(true);
		
		this.scroller = this.controller.get('scrollerId');
		
		//App Menu - Remove default items and add only Help items.
		var appMenuModel = {
			visible: false,
			items: [
				{label: $L("New Session"), command: "do-newSession"},
				{label: $L("Preferences..."), command: "do-prefs"}
			]
		};
		this.controller.setupWidget(Mojo.Menu.appMenu, {omitDefaultItems:true}, appMenuModel);		

		// Listen for scene scope keyboard events.
		this.controller.document.addEventListener("keydown", this._onKeyDownEventHandler, true);
		
		this.headerHeight = parseInt(this.controller.get('header').getStyle('height'), 10);
		this.footerHeight = parseInt(this.controller.get('footer').getStyle('height'), 10);
		this.terminalWidth = this.controller.window.innerWidth;
		this.terminalHeight = this.controller.window.innerHeight - this.headerHeight - this.footerHeight;
		
        this.termplugin = this.controller.document.createElement('object');
        this.termplugin.setAttribute('type', 'application/x-webosinternals-termplugin');
        this.termplugin.setAttribute('width', this.terminalWidth);
        this.termplugin.setAttribute('height', 1000*8);
        
        this.controller.document.addEventListener("keydown", this._onKeyDownEventHandler, true);
                
        this.placeholder = this.controller.get('install_object_here');
        this.placeholder.parentNode.replaceChild(this.termplugin, this.placeholder);
        		
	} catch (e) {
		
		Mojo.Log.logException(e, 'PageAssistant#setup');
		
	}

        this.scroller.setStyle({'height':this.terminalHeight+5+'px'});
	
}

SessionAssistant.prototype.activate = function(event) {
	
    this.termplugin.setFont(Prefs.fontWidth,Prefs.fontHeight);
    this.termplugin.setColors(Prefs.fgColor,Prefs.bgColor);
    this.termplugin.focus();
    this.termplugin.setTerminalHeight(this.terminalHeight);
    this.scroller.mojo.revealBottom();
    
}


SessionAssistant.prototype.deactivate = function(event) {

}

SessionAssistant.prototype.cleanup = function(event) {

}

SessionAssistant.prototype._onKeyDownEvent = function(event) {
	
	if (event.keyCode==13) {
		this.termplugin.sendEnter();
	}
	
}

SessionAssistant.prototype.handleCommand = function(event) {
	
	if (event.type == Mojo.Event.command) {

		switch (event.command) {
                            
                        case 'do-newSession':
                                var appController = Mojo.Controller.getAppController();
                                var f = function(stageController) {
                                        stageController.pushScene("session");       
                                };
                                var stageName = "session-" + Date.now();
                                appController.createStageWithCallback({name: stageName, lightweight: true}, f);
                                break;
                        case 'do-prefs':
                                var appController = Mojo.Controller.getAppController();
                                var stageController = appController.getActiveStageController();
                                stageController.pushScene('prefs');
                                break;
				
		}
		
    }
	
}
